#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# Script para descargar archivos desde goear.
# Más información en: http://logicerror.wordpress.com/2007/08/12/script-en-python-para-descargar-los-archivos-de-goear/

# Importamos algunos módulos que luego usaremos en el script:

from xml.dom import minidom
import urllib2

# Hay que pedir la url y encontrar su ID (La url es similar a http://www.goear.com/listen.php?v=xxyyzz):

audio_url = str(raw_input("Ingrese la dirección (url) del archivo: "))

inicio_id = audio_url.find("v=")
fin_id = len(audio_url)

audio_id = audio_url[inicio_id+2:fin_id]

# Abrir el archivo xml que contiene la información (de la forma http://www.goear.com/files/sst/secmxxyyzz.xml)

url_xml = "http://www.goear.com/files/sst/secm" + audio_id + ".xml"

xmldoc = urllib2.urlopen(url_xml)
xml_data = minidom.parse(xmldoc)
xmldoc.close()
data = xml_data.toxml()

# Buscar la linea song path=

inicio_path = data.find("path=")
fin_path = data.find(".mp3")

path = data[inicio_path+6:fin_path+4]

# Ahora hay que descargar el archivo:

print "\nBajando... espere un momento... \n\nEsto puede tomar unos minutos dependiendo del tamaño del archivo\n"

archivo = urllib2.urlopen(path)
copia = open("musica.mp3","wb")
for linea in archivo:
    copia.write(linea)
copia.close()
archivo.close()

print "Listo, ahora solo abra el archivo llamado musica.mp3"
